package com.franckbarbier.My_device;

public class My_device {

    /**
     * Business data
     */
    private Port _port = new Port();
    /**
     * UML state machine
     */
    com.pauware.pauware_engine.Core.AbstractState _Idle;
    com.pauware.pauware_engine.Core.AbstractState _S11;
    com.pauware.pauware_engine.Core.AbstractState _S12;
    com.pauware.pauware_engine.Core.AbstractState _S21;
    com.pauware.pauware_engine.Core.AbstractState _S22;
    com.pauware.pauware_engine.Core.AbstractState _S31;
    com.pauware.pauware_engine.Core.AbstractState _S32;
    com.pauware.pauware_engine.Core.AbstractState _S1;
    com.pauware.pauware_engine.Core.AbstractState _S2;
    com.pauware.pauware_engine.Core.AbstractState _S3;
    com.pauware.pauware_engine.Core.AbstractState _Busy;
    com.pauware.pauware_engine.Core.AbstractStateMachine _My_device_state_machine;

    private void init_structure() throws com.pauware.pauware_engine.Exceptions.State_exception {
    }

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Idle = new com.pauware.pauware_engine.Core.State("Idle");
        _Idle.inputState();
        _Idle.stateInvariant(_port, "isClosed");
        _S11 = (new com.pauware.pauware_engine.Core.State("S11").set_entryAction(this, "w")).set_exitAction(this, "x");
        _S11.inputState();
        _S12 = (new com.pauware.pauware_engine.Core.State("S12")).set_entryAction(this, "y").set_exitAction(this, "z");
        _S21 = new com.pauware.pauware_engine.Core.State("S21");
        _S22 = new com.pauware.pauware_engine.Core.State("S22").set_entryAction(this, "request_h", null, com.pauware.pauware_engine.Core.AbstractState.Reentrance);
        _S22.inputState();
        _S31 = new com.pauware.pauware_engine.Core.State("S31");
        _S32 = new com.pauware.pauware_engine.Core.State("S32");
        _S32.doActivity(_port, "listenTo");
        _S1 = (_S11.xor(_S12)).name("S1");
        _S2 = (_S21.xor(_S22)).name("S2");
        _S3 = _S31.and(_S32).name("S3");
        _Busy = (_S1.and(_S2)).and(_S3).name("Busy");
        _Busy.set_entryAction(_port, "setOpen", new Object[]{Boolean.valueOf(true)});
        _Busy.stateInvariant(_port, "isOpen");
        _My_device_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Idle.xor(_Busy), "My device", com.pauware.pauware_engine.Core.AbstractStateMachine.Show_on_system_out, new com.pauware.pauware2web.PauWare2Web_client());
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.fires("request_b", _S1, _S12);
        _My_device_state_machine.fires("request_c", _Busy, _S12); // Cross orthogonal region...
        _My_device_state_machine.fires("request_c", _Busy, _S22); // Cross orthogonal region...
        _My_device_state_machine.fires("request_d", _Busy, _S21); // Cross orthogonal region...
        _My_device_state_machine.fires("request_e", _Busy, _Idle);
        _My_device_state_machine.fires("request_f", _S21, _Idle); // Cross orthogonal region from inside to outside...
        _My_device_state_machine.fires("request_g", _S12, _S11);
        _My_device_state_machine.fires("request_h", _S31, _S31, true, this, "a");
        _My_device_state_machine.fires("go", _Idle, _Busy);
        /**
         * TEST
         */
// Transition causes problem due to 'guard' returns 'true' and thus conflicts with immediately prior transition:
//        _My_device_state_machine.fires("go", _Idle, _Busy, this, "guard");

// Indeterminism -> *error*:
//        _My_device_state_machine.fires("indeterminism", _Idle, _S21);
//        _My_device_state_machine.fires("indeterminism", _Idle, _S22);
// Indeterminism (variation) -> *error*:
//        _My_device_state_machine.fires("indeterminism", _Idle, _Busy);
//        _My_device_state_machine.fires("indeterminism", _Idle, _S21);
// Overriding:
//        _My_device_state_machine.fires("request_e", _S2, _Idle);
        /**
         * End of TEST
         */
        _My_device_state_machine.start();
    }

    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.stop();
    }

    public My_device() throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_structure();
        init_behavior();
    }

    /**
     * UML events
     */
    public void request_b() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("request_b");
    }

    public void request_c() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("request_c");
    }

    public void request_d() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("request_d");
    }

    public void request_e() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("request_e", com.pauware.pauware_engine.Core.AbstractStateMachine.Compute_invariants);
    }

    public void request_f() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("request_f");
    }

    public void request_g() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("request_g");
    }

    public void request_h() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("request_h");
    }

    public void go() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _My_device_state_machine.run_to_completion("go", com.pauware.pauware_engine.Core.AbstractStateMachine.Compute_invariants);
    }

    /**
     * For test purposes only...
     */
//    public void indeterminism() throws com.pauware.pauware_engine.Exceptions.State_exception {
//        _My_device_state_machine.run_to_completion("indeterminism");
//    }
    /**
     * End of test
     */
    /**
     * UML actions
     */
    public void a() {
        System.out.println("\ta activated\n");
    }

    public void w() {
        System.out.println("\tw activated\n");
    }

    public void x() {
        System.out.println("\tx activated\n");
// For testing purposes only:
//        _port = null; // NullPointerException simulation to create problems...
//        _port.setOpen(Boolean.FALSE);
    }

    public void y() {
        System.out.println("\ty activated\n");
    }

    public void z() {
        System.out.println("\tz activated\n");
    }

    /**
     * UML guards
     */
// For testing purposes only:
//    public boolean guard() {
//        return true;
//    }
    public static void main(String args[]) {
        try {
            My_device md = new My_device();
            md.start();
            for (int i = 0; i < 2; i++) {
                md.go();
                /* Indeterminism -> *error*: */
                // md.indeterminism();
                md.request_d();
                md.request_c();
                md.request_g();
                md.request_f();
            }
            md.stop();
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }
}
